/***********************************************************************
 *      This example program is an excerpt from the book:              *
 *                                                                     *
 *          X Window OSF/Motif Toolkit Programming (I)                 *
 *            - Programming Basics, Resource and Event -               *
 *                                                                     *
 *      Copyright 1994, Hideyuki Hayashi                               *
 *                                                                     *
 *      This program can be distributed without fee, provided          *
 *      that the above copyright notice appear in all copies.          *
 ***********************************************************************/

#include <Xm/XmAll.h>

main(argc, argv)
    int  argc;
    char **argv;
{
    XtAppContext app_context;
    Widget toplevel, rowcol, toggle, text, button;
    Arg    al[20];
    int    ac;

    /* Declare the resoruce arg list for rowcolumn */
    static Arg args[] = {
        { XmNmarginWidth,  (XtArgVal) 20},  /* margin width */
        { XmNmarginHeight, (XtArgVal) 10},  /* margin height */
    };

    /* Text shown on the text field */
    static char value[] = "Initial text";

    XtSetLanguageProc(NULL, NULL, NULL);

    ac = 0;
    /* Store resource name and resource value into arg list */
    XtSetArg(al[ac], XmNmaxWidth, 400); ac++; /* Maximum allowable width */
    XtSetArg(al[ac], XmNmaxHeight, 200); ac++; /* Maximum allowable height */
    toplevel = XtAppInitialize(&app_context, "Setresource", NULL, 0,
                               &argc, argv, NULL, al, ac);
                                               /* A   A */
                             /* Set resources when creating toplevel shell */

    /* Set the resource with the declared arg list */
    rowcol = XmCreateRowColumn(toplevel, "rowcol", args, XtNumber(args));
    XtManageChild(rowcol);                             /* AAAAAAAAAA */
    /* XtNumber() is a macro which counts the number of the element in the struct */

    ac = 0;
    /* Store resource name and resource value into arg list */
    XtSetArg(al[ac], XmNset, True); ac++; /* Set the toggle ON */
    toggle = XmCreateToggleButton(rowcol, "toggle", al, ac);
    XtManageChild(toggle);                       /* A   A */
                             /* Set resources when creating widget */
    ac = 0;
    /* Store resource name and resource value into arg list */
    XtSetArg(al[ac], XmNvalue, value); ac++; /* Set the text */
    text = XmCreateTextField(rowcol, "text", al, ac);
    XtManageChild(text);                  /* A   A */

    ac = 0;
    /* Store resource name and resource value into arg list */
    XtSetArg(al[ac], XmNmarginWidth, 10); ac++; /* left and right margin */
    XtSetArg(al[ac], XmNmarginHeight, 10); ac++; /* upper and lower margin */
    button = XtCreateManagedWidget("button", xmPushButtonWidgetClass,
                                   rowcol, al, ac);
                                        /* A   A */
    XtRealizeWidget(toplevel);
    XtAppMainLoop(app_context);
}
